| Version: 3.3.1

Public Member Functions | List of all members
wxWebViewEvent Class Reference
Class List by Category » Events | Class List by Category » WebView

`#include <wx/webview.h>`

Inheritance diagram for wxWebViewEvent:
[legend]

## Detailed Description

A navigation event holds information about events associated with wxWebView objects.

## Events emitted by this class

The following event handler macros redirect the events to member function handlers 'func' with prototypes like:

void handlerFuncName(wxWebViewEvent& event)

Event macros for events emitted by this class:

- EVT_WEBVIEW_CREATED(id, func):
  Process a `wxEVT_WEBVIEW_CREATED` event, generated when the object is fully initialized. For the backends using asynchronous initialization, such as wxWebViewChromium, most of this class member functions can be only used once this event is received.
- EVT_WEBVIEW_NAVIGATING(id, func):
  Process a `wxEVT_WEBVIEW_NAVIGATING` event, generated before trying to get a resource. This event may be vetoed to prevent navigating to this resource. Note that if the displayed HTML document has several frames, one such event will be generated per frame.
- EVT_WEBVIEW_NAVIGATED(id, func):
  Process a `wxEVT_WEBVIEW_NAVIGATED` event generated after it was confirmed that a resource would be requested. This event may not be vetoed. Note that if the displayed HTML document has several frames, one such event will be generated per frame.
- EVT_WEBVIEW_LOADED(id, func):
  Process a `wxEVT_WEBVIEW_LOADED` event generated when the document is fully loaded and displayed. Note that if the displayed HTML document has several frames, one such event will be generated per frame.
- EVT_WEBVIEW_ERROR(id, func):
  Process a `wxEVT_WEBVIEW_ERROR` event generated when a navigation error occurs. The integer associated with this event will be a wxWebViewNavigationError item. The string associated with this event may contain a backend-specific more precise error message/code.
- EVT_WEBVIEW_NEWWINDOW(id, func):
  Process a `wxEVT_WEBVIEW_NEWWINDOW` event, generated when a new window is created. You must handle this event if you want anything to happen, for example to load the page in a new window or tab. For usage details see wxWebViewWindowFeatures.
- EVT_WEBVIEW_NEWWINDOW_FEATURES(id, func):
  Process a `wxEVT_WEBVIEW_NEWWINDOW_FEATURES` event, generated when window features are available for the new window. For usage details see wxWebViewWindowFeatures. only available in wxWidgets 3.3.0 or later.
- EVT_WEBVIEW_WINDOW_CLOSE_REQUESTED(id, func):
  Process a `wxEVT_WEBVIEW_WINDOW_CLOSE_REQUESTED` event, generated when a window is requested to be closed. only available in wxWidgets 3.3.0 or later.
- EVT_WEBVIEW_TITLE_CHANGED(id, func):
  Process a `wxEVT_WEBVIEW_TITLE_CHANGED` event, generated when the page title changes. Use GetString to get the title.
- EVT_WEBVIEW_FULLSCREEN_CHANGED(id, func):
  Process a `wxEVT_WEBVIEW_FULLSCREEN_CHANGED` event, generated when the page wants to enter or leave fullscreen. Use GetInt to get the status. Not implemented for the IE backend and is only available in wxWidgets 3.1.5 or later.
- EVT_WEBVIEW_SCRIPT_MESSAGE_RECEIVED(id, func):
  Process a `wxEVT_WEBVIEW_SCRIPT_MESSAGE_RECEIVED` event only available in wxWidgets 3.1.5 or later. For usage details see wxWebView::AddScriptMessageHandler().
- EVT_WEBVIEW_SCRIPT_RESULT(id, func):
  Process a `wxEVT_WEBVIEW_SCRIPT_RESULT` event only available in wxWidgets 3.1.6 or later. For usage details see wxWebView::RunScriptAsync().
- wxEVT_WEBVIEW_BROWSING_DATA_CLEARED(id, func):
  Process a `wxEVT_WEBVIEW_BROWSING_DATA_CLEARED` event only available in wxWidgets 3.3.0 or later. For usage details see wxWebView::ClearBrowsingData().

Since
  2.9.3

  ##

Library: wxWebView
Category: Events, WebView

See also
  wxWebView

## Public Member Functions
| wxWebViewEvent ()
| wxWebViewEvent (wxEventType type, int id, const wxString href, const wxString target, wxWebViewNavigationActionFlags flags=wxWEBVIEW_NAV_ACTION_NONE, const wxString &messageHandler=wxString())
const wxString & | GetTarget () const
| Get the name of the target frame which the url of this event has been or will be loaded into. More...
const wxString & | GetURL () const
| Get the URL being visited. More...
wxWebViewNavigationActionFlags | GetNavigationAction () const
| Get the type of navigation action. More...
const wxString & | GetMessageHandler () const
| Get the name of the script handler. More...
wxWebViewWindowFeatures * | GetTargetWindowFeatures () const
| Get information about the target window. More...
bool | IsError () const
| Returns true if the operation failed. More...
bool | IsTargetMainFrame () const
| Returns true if the navigation target is the main frame. More...
Public Member Functions inherited from wxNotifyEvent
| wxNotifyEvent (wxEventType eventType=wxEVT_NULL, int id=0)
| Constructor (used internally by wxWidgets only). More...
void | Allow ()
| This is the opposite of Veto(): it explicitly allows the event to be processed. More...
bool | IsAllowed () const
| Returns true if the change is allowed (Veto() hasn't been called) or false otherwise (if it was). More...
void | Veto ()
| Prevents the change announced by this event from happening. More...
Public Member Functions inherited from wxCommandEvent
| wxCommandEvent (wxEventType commandEventType=wxEVT_NULL, int id=0)
| Constructor. More...
void * | GetClientData () const
| Returns client data pointer for a listbox or choice selection event (not valid for a deselection). More...
wxClientData * | GetClientObject () const
| Returns client object pointer for a listbox or choice selection event (not valid for a deselection). More...
long | GetExtraLong () const
| Returns extra information dependent on the event objects type. More...
int | GetInt () const
| Returns the integer identifier corresponding to a listbox, choice or radiobox selection (only if the event was a selection, not a deselection), or a boolean value representing the value of a checkbox. More...
int | GetSelection () const
| Returns item index for a listbox or choice selection event (not valid for a deselection). More...
wxString | GetString () const
| Returns item string for a listbox or choice selection event. More...
bool | IsChecked () const
| This method can be used with checkbox and menu events: for the checkboxes, the method returns true for a selection event and false for a deselection one. More...
bool | IsSelection () const
| For a listbox or similar event, returns true if it is a selection, false if it is a deselection. More...
void | SetClientData (void *clientData)
| Sets the client data for this event. More...
void | SetClientObject (wxClientData *clientObject)
| Sets the client object for this event. More...
void | SetExtraLong (long extraLong)
| Sets the m_extraLong member. More...
void | SetInt (int intCommand)
| Sets the m_commandInt member. More...
void | SetString (const wxString &string)
| Sets the m_commandString member. More...
Public Member Functions inherited from wxEvent
| wxEvent (int id=0, wxEventType eventType=wxEVT_NULL)
| Constructor. More...
virtual wxEvent * | Clone () const =0
| Returns a copy of the event. More...
wxObject * | GetEventObject () const
| Returns the object (usually a window) associated with the event, if any. More...
wxEventType | GetEventType () const
| Returns the identifier of the given event type, such as `wxEVT_BUTTON`. More...
virtual wxEventCategory | GetEventCategory () const
| Returns a generic category for this event. More...
int | GetId () const
| Returns the identifier associated with this event, such as a button command id. More...
wxObject * | GetEventUserData () const
| Return the user data associated with a dynamically connected event handler. More...
bool | GetSkipped () const
| Returns true if the event handler should be skipped, false otherwise. More...
long | GetTimestamp () const
| Gets the timestamp for the event. More...
bool | IsCommandEvent () const
| Returns true if the event is or is derived from wxCommandEvent else it returns false. More...
void | ResumePropagation (int propagationLevel)
| Sets the propagation level to the given value (for example returned from an earlier call to wxEvent::StopPropagation). More...
void | SetEventObject (wxObject *object)
| Sets the originating object. More...
void | SetEventType (wxEventType type)
| Sets the event type. More...
void | SetId (int id)
| Sets the identifier associated with this event, such as a button command id. More...
void | SetTimestamp (long timeStamp=0)
| Sets the timestamp for the event. More...
bool | ShouldPropagate () const
| Test if this event should be propagated or not, i.e. if the propagation level is currently greater than 0. More...
void | Skip (bool skip=true)
| This method can be used inside an event handler to control whether further event handlers bound to this event will be called after the current one returns. More...
int | StopPropagation ()
| Stop the event from propagating to its parent window. More...
Public Member Functions inherited from wxObject
| wxObject ()
| Default ctor; initializes to nullptr the internal reference data. More...
| wxObject (const wxObject &other)
| Copy ctor. More...
virtual | ~wxObject ()
| Destructor. More...
virtual wxClassInfo * | GetClassInfo () const
| This virtual function is redefined for every class that requires run-time type information, when using the wxDECLARE_CLASS macro (or similar). More...
wxObjectRefData * | GetRefData () const
| Returns the wxObject::m_refData pointer, i.e. the data referenced by this object. More...
bool | IsKindOf (const wxClassInfo *info) const
| Determines whether this class is a subclass of (or the same class as) the given class. More...
bool | IsSameAs (const wxObject &obj) const
| Returns true if this object has the same data pointer as obj. More...
void | Ref (const wxObject &clone)
| Makes this object refer to the data in clone. More...
void | SetRefData (wxObjectRefData *data)
| Sets the wxObject::m_refData pointer. More...
void | UnRef ()
| Decrements the reference count in the associated data, and if it is zero, deletes the data. More...
void | UnShare ()
| This is the same of AllocExclusive() but this method is public. More...
void | operator delete (void *buf)
| The delete operator is defined for debugging versions of the library only, when the identifier `__WXDEBUG__` is defined. More...
void * | operator new (size_t size, const wxString &filename=nullptr, int lineNum=0)
| The new operator is defined for debugging versions of the library only, when the identifier `__WXDEBUG__` is defined. More...

## Additional Inherited Members
Protected Member Functions inherited from wxObject
void | AllocExclusive ()
| Ensure that this object's data is not shared with any other object. More...
virtual wxObjectRefData * | CreateRefData () const
| Creates a new instance of the wxObjectRefData-derived class specific to this object and returns it. More...
virtual wxObjectRefData * | CloneRefData (const wxObjectRefData *data) const
| Creates a new instance of the wxObjectRefData-derived class specific to this object and initializes it copying data. More...
Protected Attributes inherited from wxEvent
int | m_propagationLevel
| Indicates how many levels the event can propagate. More...
Protected Attributes inherited from wxObject
wxObjectRefData * | m_refData
| Pointer to an object which is the object's reference-counted data. More...

## Constructor & Destructor Documentation

## ◆ wxWebViewEvent() [1/2]

wxWebViewEvent::wxWebViewEvent | ( |  | ) |

## ◆ wxWebViewEvent() [2/2]

wxWebViewEvent::wxWebViewEvent | ( | wxEventType | type,
|  | int | id,
|  | const wxString | href,
|  | const wxString | target,
|  | wxWebViewNavigationActionFlags | flags = `wxWEBVIEW_NAV_ACTION_NONE`,
|  | const wxString & | messageHandler = `wxString()`
| ) |  |

## Member Function Documentation

## ◆ GetMessageHandler()

const wxString& wxWebViewEvent::GetMessageHandler | ( |  | ) | const

Get the name of the script handler.

Only valid for events of type `wxEVT_WEBVIEW_SCRIPT_MESSAGE_RECEIVED`

Since
  3.1.5

## ◆ GetNavigationAction()

wxWebViewNavigationActionFlags wxWebViewEvent::GetNavigationAction | ( |  | ) | const

Get the type of navigation action.

Only valid for events of type `wxEVT_WEBVIEW_NEWWINDOW`

Since
  3.1.2

## ◆ GetTarget()

const wxString& wxWebViewEvent::GetTarget | ( |  | ) | const

Get the name of the target frame which the url of this event has been or will be loaded into.

This may return an empty string if the frame is not available.

## ◆ GetTargetWindowFeatures()

wxWebViewWindowFeatures* wxWebViewEvent::GetTargetWindowFeatures | ( |  | ) | const

Get information about the target window.

Only valid for events of type `wxEVT_WEBVIEW_NEWWINDOW_FEATURES`

Note
  This function is not implemented and always returns nullptr when using WebKit1 or Internet Explorer backend.

See also
  wxWebViewWindowFeatures

Since
  3.3.0

## ◆ GetURL()

const wxString& wxWebViewEvent::GetURL | ( |  | ) | const

Get the URL being visited.

## ◆ IsError()

bool wxWebViewEvent::IsError | ( |  | ) | const

Returns true if the operation failed.

Only valid for events of type `wxEVT_WEBVIEW_SCRIPT_RESULT` and `wxEVT_WEBVIEW_BROWSING_DATA_CLEARED`

Since
  3.1.6

## ◆ IsTargetMainFrame()

bool wxWebViewEvent::IsTargetMainFrame | ( |  | ) | const

Returns true if the navigation target is the main frame.

Only valid for events of type `wxEVT_WEBVIEW_NAVIGATING`

Note
  This is only available with the macOS and the Edge backend.

Since
  3.3.0